Package weka.gui.beans

# Class Join

java.lang.Object
java.awt.Component
java.awt.Container
javax.swing.JComponent
javax.swing.JPanel
weka.gui.beans.Join

All Implemented Interfaces:
  `ImageObserver`, `MenuContainer`, `Serializable`, `EventListener`, `Accessible`, `EnvironmentHandler`, `BeanCommon`, `DataSource`, `DataSourceListener`, `EventConstraints`, `InstanceListener`, `StructureProducer`, `TestSetListener`, `TrainingSetListener`, `Visible`

@KFStep(category="Flow", toolTipText="Inner join on one or more key fields") public class Join extends JPanel implements BeanCommon, Visible, Serializable, DataSource, DataSourceListener, TrainingSetListener, TestSetListener, InstanceListener, EventConstraints, StructureProducer, EnvironmentHandler

Version:
  $Revision: 11251 $
Author:
  Mark Hall (mhall{[at]}pentaho{[dot]}com)
See Also:
  - Serialized Form

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from class javax.swing.JComponent

  `JComponent.AccessibleJComponent`

  ## Nested classes/interfaces inherited from class java.awt.Component

  `Component.BaselineResizeBehavior`

- ## Field Summary

  ### Fields inherited from class javax.swing.JComponent

  `TOOL_TIP_TEXT_KEY, UNDEFINED_CONDITION, WHEN_ANCESTOR_OF_FOCUSED_COMPONENT, WHEN_FOCUSED, WHEN_IN_FOCUSED_WINDOW`

  ### Fields inherited from class java.awt.Component

  `BOTTOM_ALIGNMENT, CENTER_ALIGNMENT, LEFT_ALIGNMENT, RIGHT_ALIGNMENT, TOP_ALIGNMENT`

  ### Fields inherited from interface java.awt.image.ImageObserver

  `ABORT, ALLBITS, ERROR, FRAMEBITS, HEIGHT, PROPERTIES, SOMEBITS, WIDTH`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `Join()`
  Constructor

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `acceptDataSet(DataSetEvent e)`
  Accept and process a data set
  `void`
  `acceptInstance(InstanceEvent e)`
  Accept and process an instance event
  `void`
  `acceptTestSet(TestSetEvent e)`
  Accept and process a test set
  `void`
  `acceptTrainingSet(TrainingSetEvent e)`
  Accept and process a training set
  `void`
  `addDataSourceListener(DataSourceListener dsl)`
  Add a data source listener
  `void`
  `addInstanceListener(InstanceListener dsl)`
  Add an instance listener
  `boolean`
  `connectionAllowed(EventSetDescriptor esd)`
  Returns true if the named connection can be made at this time
  `boolean`
  `connectionAllowed(String eventName)`
  Returns true if the named connection can be made at this time
  `void`
  `connectionNotification(String eventName, Object source)`
  Deals with a new connection
  `void`
  `disconnectionNotification(String eventName, Object source)`
  Handles cleanup when an upstream step disconnects
  `boolean`
  `eventGeneratable(String eventName)`
  Returns true if, at the current time, the named event could be generated.
  `String`
  `getCustomName()`
  Get the custom name of this step
  `String`
  `getKeySpec()`
  Get the key specification (in internal format - k11,k12,...,k1nKEY_SPEC_SEPARATORk21,k22,...,k2n)
  `Instances`
  `getStructure(String eventName)`
  Get the output instances structure given an input event type
  `BeanVisual`
  `getVisual()`
  Get the visual for this step
  `String`
  `globalInfo()`
  Global info for the method
  `boolean`
  `isBusy()`
  Returns true if we are doing something
  `void`
  `removeDataSourceListener(DataSourceListener dsl)`
  Remove a data souce listener
  `void`
  `removeInstanceListener(InstanceListener dsl)`
  Remove an instance listener
  `void`
  `setCustomName(String name)`
  Set a custom name for this step
  `void`
  `setEnvironment(Environment env)`
  Set environment variables to use
  `void`
  `setKeySpec(String ks)`
  Set the key specification (in internal format - k11,k12,...,k1nKEY_SPEC_SEPARATORk21,k22,...,k2n)
  `void`
  `setLog(Logger logger)`
  Set a log to use
  `void`
  `setVisual(BeanVisual newVisual)`
  Set the visual for this step
  `void`
  `stop()`
  Attempt to stop processing
  `void`
  `useDefaultVisual()`
  Use the default visual for this step

  ### Methods inherited from class javax.swing.JPanel

  `getAccessibleContext, getUI, getUIClassID, setUI, updateUI`

  ### Methods inherited from class javax.swing.JComponent

  `addAncestorListener, addNotify, addVetoableChangeListener, computeVisibleRect, contains, createToolTip, disable, enable, firePropertyChange, firePropertyChange, firePropertyChange, getActionForKeyStroke, getActionMap, getAlignmentX, getAlignmentY, getAncestorListeners, getAutoscrolls, getBaseline, getBaselineResizeBehavior, getBorder, getBounds, getClientProperty, getComponentPopupMenu, getConditionForKeyStroke, getDebugGraphicsOptions, getDefaultLocale, getFontMetrics, getGraphics, getHeight, getInheritsPopupMenu, getInputMap, getInputMap, getInputVerifier, getInsets, getInsets, getListeners, getLocation, getMaximumSize, getMinimumSize, getNextFocusableComponent, getPopupLocation, getPreferredSize, getRegisteredKeyStrokes, getRootPane, getSize, getToolTipLocation, getToolTipText, getToolTipText, getTopLevelAncestor, getTransferHandler, getVerifyInputWhenFocusTarget, getVetoableChangeListeners, getVisibleRect, getWidth, getX, getY, grabFocus, hide, isDoubleBuffered, isLightweightComponent, isManagingFocus, isOpaque, isOptimizedDrawingEnabled, isPaintingForPrint, isPaintingTile, isRequestFocusEnabled, isValidateRoot, paint, paintImmediately, paintImmediately, print, printAll, putClientProperty, registerKeyboardAction, registerKeyboardAction, removeAncestorListener, removeNotify, removeVetoableChangeListener, repaint, repaint, requestDefaultFocus, requestFocus, requestFocus, requestFocusInWindow, resetKeyboardActions, reshape, revalidate, scrollRectToVisible, setActionMap, setAlignmentX, setAlignmentY, setAutoscrolls, setBackground, setBorder, setComponentPopupMenu, setDebugGraphicsOptions, setDefaultLocale, setDoubleBuffered, setEnabled, setFocusTraversalKeys, setFont, setForeground, setInheritsPopupMenu, setInputMap, setInputVerifier, setMaximumSize, setMinimumSize, setNextFocusableComponent, setOpaque, setPreferredSize, setRequestFocusEnabled, setToolTipText, setTransferHandler, setVerifyInputWhenFocusTarget, setVisible, unregisterKeyboardAction, update`

  ### Methods inherited from class java.awt.Container

  `add, add, add, add, add, addContainerListener, addPropertyChangeListener, addPropertyChangeListener, applyComponentOrientation, areFocusTraversalKeysSet, countComponents, deliverEvent, doLayout, findComponentAt, findComponentAt, getComponent, getComponentAt, getComponentAt, getComponentCount, getComponents, getComponentZOrder, getContainerListeners, getFocusTraversalKeys, getFocusTraversalPolicy, getLayout, getMousePosition, insets, invalidate, isAncestorOf, isFocusCycleRoot, isFocusCycleRoot, isFocusTraversalPolicyProvider, isFocusTraversalPolicySet, layout, list, list, locate, minimumSize, paintComponents, preferredSize, printComponents, remove, remove, removeAll, removeContainerListener, setComponentZOrder, setFocusCycleRoot, setFocusTraversalPolicy, setFocusTraversalPolicyProvider, setLayout, transferFocusDownCycle, validate`

  ### Methods inherited from class java.awt.Component

  `action, add, addComponentListener, addFocusListener, addHierarchyBoundsListener, addHierarchyListener, addInputMethodListener, addKeyListener, addMouseListener, addMouseMotionListener, addMouseWheelListener, bounds, checkImage, checkImage, contains, createImage, createImage, createVolatileImage, createVolatileImage, dispatchEvent, enable, enableInputMethods, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, getBackground, getBounds, getColorModel, getComponentListeners, getComponentOrientation, getCursor, getDropTarget, getFocusCycleRootAncestor, getFocusListeners, getFocusTraversalKeysEnabled, getFont, getForeground, getGraphicsConfiguration, getHierarchyBoundsListeners, getHierarchyListeners, getIgnoreRepaint, getInputContext, getInputMethodListeners, getInputMethodRequests, getKeyListeners, getLocale, getLocation, getLocationOnScreen, getMouseListeners, getMouseMotionListeners, getMousePosition, getMouseWheelListeners, getName, getParent, getPropertyChangeListeners, getPropertyChangeListeners, getSize, getToolkit, getTreeLock, gotFocus, handleEvent, hasFocus, imageUpdate, inside, isBackgroundSet, isCursorSet, isDisplayable, isEnabled, isFocusable, isFocusOwner, isFocusTraversable, isFontSet, isForegroundSet, isLightweight, isMaximumSizeSet, isMinimumSizeSet, isPreferredSizeSet, isShowing, isValid, isVisible, keyDown, keyUp, list, list, list, location, lostFocus, mouseDown, mouseDrag, mouseEnter, mouseExit, mouseMove, mouseUp, move, nextFocus, paintAll, postEvent, prepareImage, prepareImage, remove, removeComponentListener, removeFocusListener, removeHierarchyBoundsListener, removeHierarchyListener, removeInputMethodListener, removeKeyListener, removeMouseListener, removeMouseMotionListener, removeMouseWheelListener, removePropertyChangeListener, removePropertyChangeListener, repaint, repaint, repaint, requestFocus, requestFocusInWindow, resize, resize, setBounds, setBounds, setComponentOrientation, setCursor, setDropTarget, setFocusable, setFocusTraversalKeysEnabled, setIgnoreRepaint, setLocale, setLocation, setLocation, setMixingCutoutShape, setName, setSize, setSize, show, show, size, toString, transferFocus, transferFocusBackward, transferFocusUpCycle`

  ### Methods inherited from class java.lang.Object

  `equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### Join

    public Join()
    Constructor

- ## Method Details

  - ### globalInfo

    public String globalInfo()
    Global info for the method
    Returns:
      the global help info

  - ### setKeySpec

    public void setKeySpec(String ks)
    Set the key specification (in internal format - k11,k12,...,k1nKEY_SPEC_SEPARATORk21,k22,...,k2n)
    Parameters:
      `ks` - the keys specification

  - ### getKeySpec

    public String getKeySpec()
    Get the key specification (in internal format - k11,k12,...,k1nKEY_SPEC_SEPARATORk21,k22,...,k2n)
    Returns:
      the keys specification

  - ### eventGeneratable

    public boolean eventGeneratable(String eventName)
    Description copied from interface: `EventConstraints`
    Returns true if, at the current time, the named event could be generated.
    Specified by:
      `eventGeneratable` in interface `EventConstraints`
    Parameters:
      `eventName` - the name of the event in question
    Returns:
      true if the named event could be generated

  - ### acceptInstance

    public void acceptInstance(InstanceEvent e)
    Description copied from interface: `InstanceListener`
    Accept and process an instance event
    Specified by:
      `acceptInstance` in interface `InstanceListener`
    Parameters:
      `e` - an `InstanceEvent` value

  - ### acceptTestSet

    public void acceptTestSet(TestSetEvent e)
    Accept and process a test set
    Specified by:
      `acceptTestSet` in interface `TestSetListener`
    Parameters:
      `e` - the test set event encapsulating the test set

  - ### acceptTrainingSet

    public void acceptTrainingSet(TrainingSetEvent e)
    Accept and process a training set
    Specified by:
      `acceptTrainingSet` in interface `TrainingSetListener`
    Parameters:
      `e` - the training set event encapsulating the training set

  - ### acceptDataSet

    public void acceptDataSet(DataSetEvent e)
    Accept and process a data set
    Specified by:
      `acceptDataSet` in interface `DataSourceListener`
    Parameters:
      `e` - the data set event encapsulating the data set

  - ### addDataSourceListener

    public void addDataSourceListener(DataSourceListener dsl)
    Add a data source listener
    Specified by:
      `addDataSourceListener` in interface `DataSource`
    Parameters:
      `dsl` - the data source listener to add

  - ### removeDataSourceListener

    public void removeDataSourceListener(DataSourceListener dsl)
    Remove a data souce listener
    Specified by:
      `removeDataSourceListener` in interface `DataSource`
    Parameters:
      `dsl` - the data source listener to remove

  - ### addInstanceListener

    public void addInstanceListener(InstanceListener dsl)
    Add an instance listener
    Specified by:
      `addInstanceListener` in interface `DataSource`
    Parameters:
      `dsl` - the instance listener to add

  - ### removeInstanceListener

    public void removeInstanceListener(InstanceListener dsl)
    Remove an instance listener
    Specified by:
      `removeInstanceListener` in interface `DataSource`
    Parameters:
      `dsl` - the instance listener to remove

  - ### useDefaultVisual

    public void useDefaultVisual()
    Use the default visual for this step
    Specified by:
      `useDefaultVisual` in interface `Visible`

  - ### setVisual

    public void setVisual(BeanVisual newVisual)
    Set the visual for this step
    Specified by:
      `setVisual` in interface `Visible`
    Parameters:
      `newVisual` - the visual to use

  - ### getVisual

    public BeanVisual getVisual()
    Get the visual for this step
    Specified by:
      `getVisual` in interface `Visible`
    Returns:
      the visual (icon)

  - ### setCustomName

    public void setCustomName(String name)
    Set a custom name for this step
    Specified by:
      `setCustomName` in interface `BeanCommon`
    Parameters:
      `name` - the custom name to use

  - ### getCustomName

    public String getCustomName()
    Get the custom name of this step
    Specified by:
      `getCustomName` in interface `BeanCommon`
    Returns:
      the custom name of this step

  - ### stop

    public void stop()
    Attempt to stop processing
    Specified by:
      `stop` in interface `BeanCommon`

  - ### isBusy

    public boolean isBusy()
    Returns true if we are doing something
    Specified by:
      `isBusy` in interface `BeanCommon`
    Returns:
      true if processing is occurring

  - ### setLog

    public void setLog(Logger logger)
    Set a log to use
    Specified by:
      `setLog` in interface `BeanCommon`
    Parameters:
      `logger` - the log to use

  - ### connectionAllowed

    public boolean connectionAllowed(EventSetDescriptor esd)
    Returns true if the named connection can be made at this time
    Specified by:
      `connectionAllowed` in interface `BeanCommon`
    Parameters:
      `esd` - the event set descriptor of the connection
    Returns:
      true if the connection is allowed

  - ### connectionAllowed

    public boolean connectionAllowed(String eventName)
    Returns true if the named connection can be made at this time
    Specified by:
      `connectionAllowed` in interface `BeanCommon`
    Parameters:
      `eventName` - the name of the connection
    Returns:
      true if the connection is allowed

  - ### connectionNotification

    public void connectionNotification(String eventName, Object source)
    Deals with a new connection
    Specified by:
      `connectionNotification` in interface `BeanCommon`
    Parameters:
      `eventName` - the event type of the connection
      `source` - the source step

  - ### disconnectionNotification

    public void disconnectionNotification(String eventName, Object source)
    Handles cleanup when an upstream step disconnects
    Specified by:
      `disconnectionNotification` in interface `BeanCommon`
    Parameters:
      `eventName` - the event type of the connection
      `source` - the source step

  - ### getStructure

    public Instances getStructure(String eventName)
    Get the output instances structure given an input event type
    Specified by:
      `getStructure` in interface `StructureProducer`
    Parameters:
      `eventName` - the name of the input event type
    Returns:
      the output instances structure (or null)

  - ### setEnvironment

    public void setEnvironment(Environment env)
    Set environment variables to use
    Specified by:
      `setEnvironment` in interface `EnvironmentHandler`
    Parameters:
      `env` - the environment variables to use